/*
 * main.c
 *
 *  Created on: 15.12.2009
 *      Author: exceed
 */

#include <gtk/gtk.h>
#include <unistd.h>
#include <stdio.h>

static void button_clicked(GtkWidget * widget, gpointer data)
{
	  gint i = * (gint *) data;
	  int pid;

	  g_print("Button #%i is pressed!\n", i);
	  if(i == 1)
	  {
		  g_print("Calling volume up\n", i);
		  pid = fork();
		  if(pid == 0)
		  {
			  execl("/usr/bin/amixer", "amixer", "sset", "Master" ,"5+" , NULL);
		  }
	  }
		  if(i == 2)
	  {
	      g_print("Calling volume down\n", i);
	      pid = fork();
	      if(pid == 0)
	      {
	    	  execl("/usr/bin/amixer", "amixer", "sset", "Master" ,"5-" , NULL);
	      }
	  }

}

static gboolean delete_event(GtkWidget * widget, GdkEvent * event, gpointer data)
{
  g_print("Delete event occurred\n");
  return FALSE;
}

static void destroy(GtkWidget * widget, gpointer data)
{
  g_print("Destroy signal sent\n");
  gtk_main_quit();
}

int main(int argc, char ** argv)
{
	GtkWidget * window;
	GtkWidget * buttonVolumeUp;
	GtkWidget * buttonVolumeDown;
	GtkWidget * box;
	gint i1, i2;
	gtk_init(&argc, &argv);

	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(window), "ALSA Volume Control");
	gtk_container_set_border_width(GTK_CONTAINER(window), 40);
	g_signal_connect(G_OBJECT(window), "delete_event", G_CALLBACK(delete_event), NULL);
	g_signal_connect(G_OBJECT(window), "destroy", G_CALLBACK(destroy), NULL);
	box = gtk_hbox_new(TRUE, 2);
	gtk_container_add(GTK_CONTAINER(window), box);
	buttonVolumeUp = gtk_button_new_with_label("Volume Up");
	i1 = 1;
	g_signal_connect(G_OBJECT(buttonVolumeUp), "clicked", G_CALLBACK(button_clicked), &i1);
	gtk_box_pack_start(GTK_BOX(box), buttonVolumeUp, TRUE, TRUE, 0);
	buttonVolumeDown = gtk_button_new_with_label("Volume Down");
	i2 = 2;
	g_signal_connect(G_OBJECT(buttonVolumeDown), "clicked", G_CALLBACK(button_clicked), &i2);
	gtk_box_pack_start(GTK_BOX(box), buttonVolumeDown, TRUE, TRUE, 0);
	gtk_widget_show(buttonVolumeUp);
	gtk_widget_show(buttonVolumeDown);
	gtk_widget_show(box);
	gtk_widget_show(window);
	gtk_main();

	return 0;
}
